Attribute VB_Name = "Module1"
Public minErrSq As Single


Public Function IsConverge(pt As point, ConvergeTo As point, iterno As Integer) As Boolean
' Checks if the point 'pt' converges under the iteration scheme defined in z_np1

    Dim LastPoint As point, NewPoint As point, count As Long
    Dim radSq As Single, DivergeRadSq As Single, ConvergeErrSq As Single
    ReDim IterPoints(1000)
    
    ConvergeErrSq = ConvergeErr * ConvergeErr
    DivergeRadSq = DivergeRad * DivergeRad
    minErrSq = DivergeRadSq
    LastPoint = pt
    count = 1
    Do
        If count > UBound(IterPoints) Then
            ReDim Preserve IterPoints(UBound(IterPoints) + 1000)
        End If
        IterPoints(count) = LastPoint
        NewPoint = z_np1(LastPoint)
        radSq = NewPoint.xc * NewPoint.xc + NewPoint.yc * NewPoint.yc
        Call getMinErr(count)
        
        
        If minErrSq < ConvergeErrSq Then
            ConvergeTo = NewPoint
            iterno = count
            IsConverge = True
            Exit Do
        End If
        
        If radSq > DivergeRadSq Then
            iterno = count
            IsConverge = False
            Exit Do
        End If
        
        count = count + 1
        LastPoint.xc = NewPoint.xc
        LastPoint.yc = NewPoint.yc
        
        If (Not (maxIter = 0)) And count > maxIter Then
            Exit Do
        End If
    Loop
End Function


Public Function z_np1(z_n As point) As point
' Defines the iteration relation

    Dim tmpX As Single, tmpY As Single
    Dim tmpPt As point
    
    Select Case SetType
    Case "Mandelbrot"
        z_np1.xc = z_n.xc * z_n.xc - z_n.yc * z_n.yc + cx
        z_np1.yc = 2 * z_n.xc * z_n.yc + cy
    Case "Mandelbar"
        z_np1.xc = z_n.xc * z_n.xc - z_n.yc * z_n.yc + cx
        z_np1.yc = -2 * z_n.xc * z_n.yc + cy
    Case "NR: z^3 = 1"
        tmpPt = cplxMult(cplxMult(z_n, z_n), z_n)
        tmpPt.xc = (tmpPt.xc - 1) / 2
        tmpPt.yc = tmpPt.yc / 2
        tmpPt = cplxDiv(tmpPt, cplxMult(z_n, z_n))
        z_np1.xc = z_n.xc - tmpPt.xc
        z_np1.yc = z_n.yc - tmpPt.yc
    End Select
End Function


Public Function getMinErr(count As Long)
' Returns the minimum distance between the points obtained in the course of iteration process

    Dim checks As Integer, thisErrSq As Single
    Dim pt As point, chekpt As point, dpt As point

    If count = 1 Then
        Exit Function
    End If
    
    pt = IterPoints(count)
    For checks = 1 To count - 1
        chekpt = IterPoints(checks)
        dpt.xc = pt.xc - chekpt.xc
        dpt.yc = pt.yc - chekpt.yc
        thisErrSq = dpt.xc * dpt.xc + dpt.yc * dpt.yc
        If thisErrSq < minErrSq Then
            minErrSq = thisErrSq
        End If
    Next checks
End Function


Public Function getInsideColor(pt As point, ConvergeTo As point, iterno As Integer) As Long
' Return colours for points inside the Set

    Dim intensity As Single
    
    intensity = iterno / 100
    If intensity > 1 Then
        intensity = 1
    End If
    getInsideColor = RGB(255 * intensity, 255 * intensity, 255 * intensity)
End Function


Public Function getOutsideColor(pt As point, ConvergeTo As point, iterno As Integer) As Long
' Return colours for points outside the Set

    Dim intensity As Single
    
    intensity = iterno / 2
    If intensity > 1 Then
        intensity = 1
    End If
    getOutsideColor = RGB(0, 0, 255 * intensity)
End Function

